Home Information Classes Download Usage Mail List Requirements Links Tutorial

# TwoPole Class Reference

STK two-pole filter class. More...

`#include <TwoPole.h>`

Inheritance diagram for TwoPole:

List of all members.

## Public Member Functions

| TwoPole ()
| Default constructor creates a second-order pass-through filter.
| ~TwoPole ()
| Class destructor.
void | clear (void)
| Clears the internal states of the filter.
void | setB0 (MY_FLOAT b0)
| Set the b[0] coefficient value.
void | setA1 (MY_FLOAT a1)
| Set the a[1] coefficient value.
void | setA2 (MY_FLOAT a2)
| Set the a[2] coefficient value.
void | setResonance (MY_FLOAT frequency, MY_FLOAT radius, bool normalize=FALSE)
| Sets the filter coefficients for a resonance at frequency (in Hz).
void | setGain (MY_FLOAT theGain)
| Set the filter gain.
MY_FLOAT | getGain (void) const
| Return the current filter gain.
MY_FLOAT | lastOut (void) const
| Return the last computed output value.
MY_FLOAT | tick (MY_FLOAT sample)
| Input one sample to the filter and return one output.
MY_FLOAT * | tick (MY_FLOAT *vector, unsigned int vectorSize)
| Input vectorSize samples to the filter and return an equal number of outputs in vector.

## Detailed Description

STK two-pole filter class.

This protected Filter subclass implements a two-pole digital filter. A method is provided for creating a resonance in the frequency response while maintaining a nearly constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 20 of file TwoPole.h.

## Member Function Documentation

void TwoPole::setResonance | ( | MY_FLOAT | frequency,
|  | MY_FLOAT | radius,
|  | bool | normalize = FALSE
| ) |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the coefficients are then normalized to produce unity gain at frequency (the actual maximum filter gain tends to be slightly greater than unity when radius is not close to one). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. For a better resonance filter, use a BiQuad filter.

See also:
  BiQuad filter class

void TwoPole::setGain | ( | MY_FLOAT | theGain | ) | `[virtual]`

| Set the filter gain. The gain is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. Reimplemented from Filter.

The documentation for this class was generated from the following file:

- TwoPole.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.